
(*
  OCaml HTTP - do it yourself (fully OCaml) HTTP daemon

  Copyright (C) <2002-2004> Stefano Zacchiroli <zack@cs.unibo.it>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

(** Minimal implementation of an HTTP 1.0/1.1 client. Interface is similar to
 * Gerd Stoplmann's Http_client module. Implementation is simpler and doesn't
 * handle HTTP redirection, proxies, ecc. The only reason for the existence of
 * this module is for performances and incremental elaboration of response's
 * bodies *)

exception Http_error of (int * string)  (* code, body *)

  (** @param url an HTTP url
   * @return HTTP response's body
   * @raise Http_error when response code <> 200 *)
val get: string -> string

  (** as above but iter callback function on HTTP response's body instead of
   * returning it as a string *)
val get_iter: (string -> unit) -> string -> unit

  (** @param url an HTTP url
   * @return HTTP HEAD raw response
   * @raise Http_error when response code <> 200 *)
val head: string -> string

